package net.sf.jpatch.boundary;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

import net.sf.jpatch.renderer.*;

public class GenericOutputSettings extends JDialog implements ActionListener {

	private int iCurveSubdiv;
	private int iPatchSubdiv;
	private boolean bUseSame;

	private JPatchSettings settings = JPatchSettings.getInstance();
	
	private JLabel labelSubdiv = new JLabel("Subdivisions:");
	private JLabel labelPatch = new JLabel("Output patches:");
	
	private JSlider sliderSubdiv = new JSlider(1,16);
	private JCheckBox checkBox = new JCheckBox();
	
	private JButton buttonOK = new JButton("OK",new ImageIcon(getClass().getClassLoader().getResource("net/sf/jpatch/images/ok.png")));
	private JButton buttonCancel = new JButton("Cancel",new ImageIcon(getClass().getClassLoader().getResource("net/sf/jpatch/images/cancel.png")));
	
	public GenericOutputSettings(Frame owner) {
		super(owner,"Generic output options",true);
		
		sliderSubdiv.setValue(4);
		
		//buttonOK.setBackground(new Color(0,255,0));
		
		GridLayout layout = new GridLayout(3,2);
		layout.setHgap(10);
		layout.setVgap(10);
		
		getContentPane().setLayout(layout);
		
		sliderSubdiv.setMinorTickSpacing(1);
		sliderSubdiv.setMajorTickSpacing(3);
		sliderSubdiv.setPaintTicks(true);
		sliderSubdiv.setPaintLabels(true);
		sliderSubdiv.setSnapToTicks(true);

		getContentPane().add(labelSubdiv);
		getContentPane().add(sliderSubdiv);
		getContentPane().add(labelPatch);
		getContentPane().add(checkBox);
		//getContentPane().add(labelSync);
		//getContentPane().add(checkBox);
		getContentPane().add(buttonOK);
		getContentPane().add(buttonCancel);
		
		
		buttonCancel.addActionListener(this);
		buttonOK.addActionListener(this);
		
		pack();
		setLocationRelativeTo(owner);
		show();
	}

	public void actionPerformed(ActionEvent actionEvent) {
		if (actionEvent.getSource() == buttonCancel) {
			setVisible(false);
			dispose();
		} else if (actionEvent.getSource() == buttonOK) {
			setVisible(false);
			if (checkBox.isSelected()) {
				JFileChooser fileChooser = new JFileChooser();
				if (fileChooser.showSaveDialog(MainFrame.getInstance()) == JFileChooser.APPROVE_OPTION) {
					File file = fileChooser.getSelectedFile();
					String filename = file.getPath();
					JPatchRenderer renderer = new TestRenderer2();
					renderer.writeToFile(filename);
				}
			} else {
				JFileChooser fileChooser = new JFileChooser();
				if (fileChooser.showSaveDialog(MainFrame.getInstance()) == JFileChooser.APPROVE_OPTION) {
					File file = fileChooser.getSelectedFile();
					String filename = file.getPath();
					JPatchRenderer renderer = new TestRenderer(sliderSubdiv.getValue() + 1);
					renderer.writeToFile(filename);
				}
			}
			dispose();
		}
	}
	
	public static void main(String[] args) {
		JDialog dialog = new GenericOutputSettings(null);
		dialog.pack();
		dialog.show();
	}
}
