package net.sf.jpatch.boundary;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import net.sf.jpatch.control.edit.*;

public class GridDialog extends JDialog implements ActionListener {

	private JLabel labelSpacing = new JLabel("Spacing:");

	private JTextField textSpacing = new JTextField("" + MainFrame.getInstance().getJPatchScreen().getGridSpacing());

	private JButton buttonOK = new JButton("OK",new ImageIcon(getClass().getClassLoader().getResource("net/sf/jpatch/images/ok.png")));
	private JButton buttonCancel = new JButton("Cancel",new ImageIcon(getClass().getClassLoader().getResource("net/sf/jpatch/images/cancel.png")));
	
	public GridDialog(Frame owner) {
		super(owner,"Grid settings",true);
		
		GridLayout layout = new GridLayout(2,2);
		layout.setHgap(10);
		layout.setVgap(10);
		
		getContentPane().setLayout(layout);

		getContentPane().add(labelSpacing);
		getContentPane().add(textSpacing);
		getContentPane().add(buttonOK);
		getContentPane().add(buttonCancel);
		
		
		buttonCancel.addActionListener(this);
		buttonOK.addActionListener(this);
		
		pack();
		setLocationRelativeTo(owner);
		show();
	}

	public void actionPerformed(ActionEvent actionEvent) {
		if (actionEvent.getSource() == buttonCancel) {
			setVisible(false);
			dispose();
		} else if (actionEvent.getSource() == buttonOK) {
			setVisible(false);
			dispose();
			MainFrame.getInstance().getJPatchScreen().setGridSpacing(new Float(textSpacing.getText()).floatValue());
			JPatchSettings.getInstance().fGridSpacing = new Float(textSpacing.getText()).floatValue();
		}
	}
}
