package net.sf.jpatch.boundary;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

import java.io.*;
import javax.vecmath.*;

import net.sf.jpatch.entity.*;

public class JPatchCanvasSWRenderer extends Canvas 
implements Viewport {

	private SWRenderer swRenderer;
	private Image image;
	
	private Model model;
	private ViewDefinition viewDefinition;
	
	private int[] aiStaticFrameBuffer;
	private int[] aiStaticZBuffer;
	
	public JPatchCanvasSWRenderer(Model model, ViewDefinition viewDefinition) {
		this.model = model;
		this.viewDefinition = viewDefinition;
		viewDefinition.setViewport(this);
		ColorModel cm = MainFrame.getInstance().getGraphicsConfiguration().getColorModel();
		swRenderer = new SWRenderer(400 ,400 ,cm ,model , viewDefinition);
		prepareImage(image,this);
		//image = createImage(swRenderer);
	}
	
	public ViewDefinition getViewDefinition() {
		return viewDefinition;
	}
	
	public void update(Graphics g) {
		//System.out.println("update");
		Dimension dimension = getSize();
		if (image == null || image.getWidth(this) != dimension.width || image.getHeight(this) != dimension.height) {
			updateImage();
		}
		if (image != null) g.drawImage(image, 0, 0, this);
	}
		
	public void paint(Graphics g) {
		System.out.println(g);
		update(g);
	}
	
	public void repaint() {
		render();
	}
	
	public void render() {
		//System.out.println("render");
		swRenderer.render();
		//image = createImage(swRenderer);
		update(getGraphics());
	}
	/*
	public void repaint() {
		System.out.println("repaint");
		swRenderer.render();
	}
	*/
	public void updateImage() {
		System.out.println("updateImage");
		int width = getSize().width;
		int height = getSize().height;
		if (image == null || image.getWidth(this) != width || image.getHeight(this) != height) {
			if (swRenderer != null) {
				aiStaticFrameBuffer = new int[width * height];
				aiStaticZBuffer = new int[width * height];
				swRenderer.resize(width, height);
				swRenderer.setActiveBuffers(aiStaticFrameBuffer, aiStaticZBuffer);
				image = createImage(swRenderer);
			}
		}
	}
}
