package net.sf.jpatch.boundary;

import java.awt.event.*;

public class JPatchKey {
	private int iKeyCode;
	private int iOnMask;
	private int iOffMask;
	
	public JPatchKey(int keyCode) {
		this(keyCode,0,0xFFFFFFFF);
	}
	
	public JPatchKey(int keyCode, int mask) {
		this(keyCode,mask,0xFFFFFFFF ^ mask);
	}
	
	public JPatchKey(int keyCode, int onMask, int offMask) {
		iKeyCode = keyCode;
		iOnMask = onMask;
		iOffMask = offMask;
	}
	
	public boolean test(KeyEvent keyEvent) {
		return (keyEvent.getKeyCode() == iKeyCode && (keyEvent.getModifiersEx() & (iOnMask | iOffMask)) == iOnMask);
	}
}

