package net.sf.jpatch.boundary;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class JPatchKeyAdapter extends KeyAdapter {
	private ArrayList listKeys = new ArrayList();
	
	public void addKey(JPatchKey key, Object object) {
		listKeys.add(key);
		listKeys.add(object);
	}
	
	public void keyPressed(KeyEvent keyEvent) {
		for (int i = 0; i < listKeys.size(); i += 2) {
			JPatchKey key = (JPatchKey)listKeys.get(i);
			if (key.test(keyEvent)) {
				Object object = listKeys.get(i + 1);
				try {
					if (Class.forName("java.awt.event.ActionListener").isInstance(object)) {
						((ActionListener) object).actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED,"Key pressed"));
					} else if (Class.forName("javax.swing.AbstractButton").isInstance(object)) {
						((AbstractButton) object).doClick();
					}
				} catch(ClassNotFoundException exception) {
					System.err.println(exception);
				}
			}
		}
	}
}
