package net.sf.jpatch.boundary;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import net.sf.jpatch.control.edit.*;

public class LatheOptions extends JDialog implements ActionListener {

	private int iCurveSubdiv;
	private int iPatchSubdiv;
	private boolean bUseSame;

	private JPatchSettings settings = JPatchSettings.getInstance();
	
	private JLabel labelSegments = new JLabel("Segments:");

	private JTextField textSegments = new JTextField("8");

	private JButton buttonOK = new JButton("OK",new ImageIcon(getClass().getClassLoader().getResource("net/sf/jpatch/images/ok.png")));
	private JButton buttonCancel = new JButton("Cancel",new ImageIcon(getClass().getClassLoader().getResource("net/sf/jpatch/images/cancel.png")));
	
	public LatheOptions(Frame owner) {
		super(owner,"Lathe options",true);
		
		GridLayout layout = new GridLayout(2,2);
		layout.setHgap(10);
		layout.setVgap(10);
		
		getContentPane().setLayout(layout);

		getContentPane().add(labelSegments);
		getContentPane().add(textSegments);
		getContentPane().add(buttonOK);
		getContentPane().add(buttonCancel);
		
		
		buttonCancel.addActionListener(this);
		buttonOK.addActionListener(this);
		
		pack();
		setLocationRelativeTo(owner);
		show();
	}

	public void actionPerformed(ActionEvent actionEvent) {
		if (actionEvent.getSource() == buttonCancel) {
			setVisible(false);
			dispose();
		} else if (actionEvent.getSource() == buttonOK) {
			setVisible(false);
			dispose();
			int segments = (new Integer(textSegments.getText())).intValue();
			if (segments >=3 && segments <=256) {
				JPatchCompoundEdit compoundEdit = new NewLatheEdit(MainFrame.getInstance().getPointSelection().getControlPointArray(), segments);
				if (compoundEdit.size() > 0) {
					MainFrame.getInstance().getUndoManager().addEdit(compoundEdit);
				}
				MainFrame.getInstance().getJPatchScreen().update_all();
			}
		}
	}
	
	public static void main(String[] args) {
		JDialog dialog = new LatheOptions(null);
		dialog.pack();
		dialog.show();
	}
}
