package net.sf.jpatch.boundary;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class QualitySettings extends JDialog implements ActionListener {

	private int iCurveSubdiv;
	private int iPatchSubdiv;
	private boolean bUseSame;

	private JPatchSettings settings = JPatchSettings.getInstance();
	
	private JLabel labelCurves = new JLabel("Curve subdivisions:");
	private JLabel labelPatches = new JLabel("Patch subdivisions:");
	private JLabel labelSync = new JLabel("Use patch values:");

	private JSlider sliderCurves = new JSlider(1,8);
	private JSlider sliderPatches = new JSlider(1,8);
	private JCheckBox checkBox = new JCheckBox();

	private JButton buttonOK = new JButton("OK",new ImageIcon(getClass().getClassLoader().getResource("net/sf/jpatch/images/ok.png")));
	private JButton buttonCancel = new JButton("Cancel",new ImageIcon(getClass().getClassLoader().getResource("net/sf/jpatch/images/cancel.png")));
	
	public QualitySettings(Frame owner) {
		super(owner,"ZBuffer render quality",true);
		
		sliderCurves.setValue(settings.iCurveSubdivisions - 1);
		sliderPatches.setValue(settings.iPatchSubdivisions - 1);
		
		//buttonOK.setBackground(new Color(0,255,0));
		
		GridLayout layout = new GridLayout(3,2);
		layout.setHgap(10);
		layout.setVgap(10);
		
		getContentPane().setLayout(layout);
		
		sliderCurves.setMinorTickSpacing(1);
		sliderCurves.setMajorTickSpacing(1);
		sliderCurves.setPaintTicks(true);
		sliderCurves.setPaintLabels(true);
		sliderCurves.setSnapToTicks(true);
		sliderPatches.setMinorTickSpacing(1);
		sliderPatches.setMajorTickSpacing(1);
		sliderPatches.setPaintTicks(true);
		sliderPatches.setPaintLabels(true);
		sliderPatches.setSnapToTicks(true);

		getContentPane().add(labelCurves);
		getContentPane().add(sliderCurves);
		getContentPane().add(labelPatches);
		getContentPane().add(sliderPatches);
		//getContentPane().add(labelSync);
		//getContentPane().add(checkBox);
		getContentPane().add(buttonOK);
		getContentPane().add(buttonCancel);
		
		
		buttonCancel.addActionListener(this);
		buttonOK.addActionListener(this);
		
		pack();
		setLocationRelativeTo(owner);
		show();
	}

	public void actionPerformed(ActionEvent actionEvent) {
		if (actionEvent.getSource() == buttonCancel) {
			setVisible(false);
			dispose();
		} else if (actionEvent.getSource() == buttonOK) {
			settings.iCurveSubdivisions = sliderCurves.getValue() + 1;
			settings.iPatchSubdivisions = sliderPatches.getValue() + 1;
			ZBufferRenderer.init();
			setVisible(false);
			dispose();
			MainFrame.getInstance().getJPatchScreen().update_all();
		}
	}
	
	public static void main(String[] args) {
		JDialog dialog = new QualitySettings(null);
		dialog.pack();
		dialog.show();
	}
}
