package net.sf.jpatch.boundary;

import java.awt.*;
import java.awt.image.*;
import java.util.*;
import javax.vecmath.*;
import net.sf.jpatch.boundary.selection.*;
import net.sf.jpatch.renderer.*;
import net.sf.jpatch.auxilary.*;
import net.sf.jpatch.entity.*;

public class SWRenderer extends ZBufferRenderer {
	public static final int EVERYTHING = 0;
	public static final int BACKGROUND = 1;
	public static final int FOREGROUND = 2;
	
	private Model model;
	private ViewDefinition viewDefinition;
	
	/*
	private Point3f[] points = new Point3f[50 * 50];
	private Vector3f[] normals = new Vector3f[50 * 50];
	private int[] colors = new int[50 * 50];
	*/
	static int COUNT = 0;
	
	public SWRenderer(Model model, ViewDefinition viewDefinition) {
		super();
		this.model = model;
		this.viewDefinition = viewDefinition;
		/*
		for (int i = 0; i < 50 * 50; i++) {
			points[i] = new Point3f();
			normals[i] = new Vector3f();
		}
		*/
	}
	/*
	public void drawXZGrid(float spacing, int size) {
		float f;
		float max = spacing * size;
		Point3f a = new Point3f();
		Point3f b = new Point3f();
		Matrix4f m4Screen = viewDefinition.getScreenMatrix();
		for (f = 0; f <= max; f += spacing) {
			a.set(-max,0,f);
			b.set(max,0,f);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
			a.set(-max,0,-f);
			b.set(max,0,-f);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
			a.set(f,0,-max);
			b.set(f,0,max);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
			a.set(-f,0,-max);
			b.set(-f,0,max);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
		}
	}
	
	public void drawXYGrid(float spacing, int size) {
		float f;
		float max = spacing * size;
		Point3f a = new Point3f();
		Point3f b = new Point3f();
		Matrix4f m4Screen = viewDefinition.getScreenMatrix();
		for (f = 0; f <= max; f += spacing) {
			a.set(-max,f,0);
			b.set(max,f,0);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
			a.set(-max,-f,0);
			b.set(max,-f,0);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
			a.set(f,-max,0);
			b.set(f,max,0);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
			a.set(-f,-max,0);
			b.set(-f,max,0);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
		}
	}
	
	public void drawYZGrid(float spacing, int size) {
		float f;
		float max = spacing * size;
		Point3f a = new Point3f();
		Point3f b = new Point3f();
		Matrix4f m4Screen = viewDefinition.getScreenMatrix();
		for (f = 0; f <= max; f += spacing) {
			a.set(0,-max,f);
			b.set(0,max,f);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
			a.set(0,-max,-f);
			b.set(0,max,-f);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
			a.set(0,f,-max);
			b.set(0,f,max);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
			a.set(0,-f,-max);
			b.set(0,-f,max);
			m4Screen.transform(a);
			m4Screen.transform(b);
			draw3DLine(a,b,Preferences.iGrid);
		}
	}
	*/
	public void render(int mode) {
		//drawXZGrid(1,10);
		//drawXYGrid(1,10);
		//drawYZGrid(1,10);
		Point3f[] controlPoints = new Point3f[] {
			new Point3f(-30,-20,-30), new Point3f(-10,0,-30), new Point3f(10,0,-30), new Point3f(30,-20,-30),
			new Point3f(-30,0,-10), new Point3f(-10,20,-10), new Point3f(10,20,-10), new Point3f(30,0,-10),
			new Point3f(-30,-0,10), new Point3f(-10,20,10), new Point3f(10,20,10), new Point3f(30,0,10),
			new Point3f(-30,-20,30), new Point3f(-10,0,30), new Point3f(10,-0,30), new Point3f(30,-20,30)
		};
		Matrix4f m4Screen = viewDefinition.getScreenMatrix();
		for (int i = 0; i < 16; i++) {
			m4Screen.transform(controlPoints[i]);
		}
		
		ArrayList alHeads = MainFrame.getInstance().getModel().allHeads();
		Point3f p3 = new Point3f();
		
		if (viewDefinition.renderPatches() && false) {
			switch(mode) {
				case EVERYTHING:
					for (Patch patch = MainFrame.getInstance().getModel().getFirstPatch(); patch != null; patch = patch.getNext()) {
						MaterialProperties materialProperties = patch.getMaterial().getMaterialProperties();
						Point3f[][] bicubicPatches = patch.bicubicPatches();
						for (int p = 0; p < bicubicPatches.length; p++) {
							Point3f[] bezierCPs = bicubicPatches[p];
							for (int i = 0; i < bezierCPs.length; i++) {
								m4Screen.transform(bezierCPs[i]);
							}
							drawBicubicPatch(bezierCPs,materialProperties);
						}
					}
				break;
				case BACKGROUND:
					for (Patch patch = MainFrame.getInstance().getModel().getFirstPatch(); patch != null; patch = patch.getNext()) {
						if (!patch.isDynamic()) {
							MaterialProperties materialProperties = patch.getMaterial().getMaterialProperties();
							Point3f[][] bicubicPatches = patch.bicubicPatches();
							for (int p = 0; p < bicubicPatches.length; p++) {
								Point3f[] bezierCPs = bicubicPatches[p];
								for (int i = 0; i < bezierCPs.length; i++) {
									m4Screen.transform(bezierCPs[i]);
								}
								drawBicubicPatch(bezierCPs,materialProperties);
							}
						}
					}
				break;
				case FOREGROUND:
					for (Patch patch = MainFrame.getInstance().getModel().getFirstPatch(); patch != null; patch = patch.getNext()) {
						if (patch.isDynamic()) {
							MaterialProperties materialProperties = patch.getMaterial().getMaterialProperties();
							Point3f[][] bicubicPatches = patch.bicubicPatches();
							for (int p = 0; p < bicubicPatches.length; p++) {
								Point3f[] bezierCPs = bicubicPatches[p];
								for (int i = 0; i < bezierCPs.length; i++) {
									m4Screen.transform(bezierCPs[i]);
								}
								drawBicubicPatch(bezierCPs,materialProperties);
							}
						}
					}
				break;
			}
		}

		if (mode != BACKGROUND) {
			PointSelection pointSelection = MainFrame.getInstance().getPointSelection();
			if (viewDefinition.renderPoints()) {
				for (int i = 0; i < alHeads.size(); i++) {
					ControlPoint cp = (ControlPoint)alHeads.get(i);
					p3.set(cp.getPosition());
					m4Screen.transform(p3);
					if (pointSelection != null && pointSelection.contains(cp)) {
						drawPoint3D(p3, 2);
					} else {
						drawPoint3D(p3, 1);
					}
				}
			}
			
			if (viewDefinition.renderCurves()) {
				Curve curve;
				ControlPoint cp;
				Point3f p3A = new Point3f();
				Point3f p3B = new Point3f();
				Point3f p3C = new Point3f();
				Point3f p3D = new Point3f();
				boolean renderPoints = viewDefinition.renderPoints();
				curve = model.getFirstCurve();
				while (curve != null) {
					cp = curve.getStart();
					if (!cp.isStartHook()) {
						p3A.set(cp.getPosition());
						p3B.set(cp.getOutTangent());
						m4Screen.transform(p3A);
						m4Screen.transform(p3B);
						cp = cp.getNext();
						while (cp != null) {
							p3C.set(cp.getInTangent());
							p3D.set(cp.getPosition());
							m4Screen.transform(p3C);
							m4Screen.transform(p3D);
							draw3DCubicCurve(p3A,p3B,p3C,p3D);
							ControlPoint cpNext = cp.getNextCheckLoop();
							if (cpNext != null) { 
								p3B.set(cp.getOutTangent());
								m4Screen.transform(p3B);
								p3A.set(p3D);
							}
							cp = cpNext;
						}
					}
					curve = curve.getNext();
				}
			}
		}
	}
}
