package net.sf.jpatch.boundary;

import net.sf.jpatch.entity.*;
import javax.vecmath.*;

public class Scanline {
	public double[][] aadValue;
	public MaterialProperties[] aMaterialProperties;
	public Color3f[] ac3Color;
	
	private int iWidth;
	private Color3f c3BackgroundColor;
	
	public Scanline(int width, int backgroundColor) {
		iWidth = width;
		c3BackgroundColor = new Color3f(0,0,1);
		aMaterialProperties = new MaterialProperties[width];
		aadValue = new double[width][Triangle.NUM_VALUES];
		ac3Color = new Color3f[width];
		for (int x = 0; x < iWidth; x++) {
			aadValue[x][Triangle.POSITION_R] = 0;
		}
	}
	
	public void shadeScanline(Shader shader) {
		//System.out.println("x");
		for (int x = 0; x < iWidth; x++) {
			if (aMaterialProperties[x] != null) {
				ac3Color[x] = shader.shade(aadValue[x],aMaterialProperties[x]);
				//System.out.println(" " + ac3Color[x]);
				//aiColor[x] = 0xFF00FF00;
				//ac3Color[x] = c3BackgroundColor;
			} else {
				//aiColor[x] = iBackgroundColor;
				ac3Color[x] = c3BackgroundColor;
			}
		}
	}
}
