package net.sf.jpatch.boundary;

import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import net.sf.jpatch.boundary.sidebar.*;
import net.sf.jpatch.boundary.selection.*;
import net.sf.jpatch.entity.*;
import net.sf.jpatch.control.edit.*;

public class SideBar extends JPanel
implements TreeSelectionListener {
	private JScrollPane scrollPane;
	private SidePanel sidePanel;
	private JPanel detailPanel = new JPanel();
	private TransformPanel transformPanel = new TransformPanel();
	
	public SideBar(JTree tree) {
		setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		//setWidth(200);
		//setPreferredSize
		//scrollPane = new JScrollPane(tree,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scrollPane = new JScrollPane(tree);
		Dimension dim = new Dimension(198,300);
		scrollPane.setPreferredSize(dim);
		scrollPane.setMinimumSize(dim);
		scrollPane.setMaximumSize(dim);
		//add(new JLabel("Tree",SwingConstants.LEFT));
		sidePanel = new SidePanel();
		dim = new Dimension(200,100);
		transformPanel.setPreferredSize(dim);
		transformPanel.setMinimumSize(dim);
		transformPanel.setMaximumSize(dim);
		add(transformPanel);
		add(scrollPane);
		//add(new JSeparator(SwingConstants.HORIZONTAL));
		add(sidePanel);
		//detailPanel.add(new JLabel("test"));
		add(detailPanel);
		tree.setFocusable(false);
		tree.addTreeSelectionListener(this);
		//detailPanel.setLayout(new GridLayout(10,1));
		dim = new Dimension(198,1000);
		detailPanel.setPreferredSize(dim);
		detailPanel.setMinimumSize(dim);
		detailPanel.setMaximumSize(dim);
	}
	
	
	public void replacePanel(SidePanel newSidePanel) {
		remove(sidePanel);
		add(newSidePanel,2);
		sidePanel = newSidePanel;
		//sidePanel.setBorder(BorderFactory.createLineBorder(new Color(0,0,0)));
	}
	
	public void setTree(JTree tree) {
		remove(scrollPane);
		scrollPane = new JScrollPane(tree);
		Dimension dim = new Dimension(198,300);
		scrollPane.setPreferredSize(dim);
		scrollPane.setMinimumSize(dim);
		scrollPane.setMaximumSize(dim);
		tree.setFocusable(false);
		tree.addTreeSelectionListener(this);
		add(scrollPane,1);
		validate();
		//scrollPane.add(tree);
	}
	
	public void clearDetailPanel() {
		detailPanel.removeAll();
		detailPanel.repaint();
	}
	
	public JPanel getDetailPanel() {
		return detailPanel;
	}
	
	public void valueChanged(TreeSelectionEvent treeSelectionEvent) {
		//System.out.println(treeSelectionEvent);
		//System.out.println(treeSelectionEvent.getPath());
		Object[] aobjectPath = treeSelectionEvent.getPath().getPath();
		JPatchTreeLeaf selectedLeaf = (JPatchTreeLeaf)aobjectPath[aobjectPath.length - 1];
		switch(selectedLeaf.getNodeType()) {
			case JPatchTreeNode.MODEL:
				replacePanel(new ModelPanel((Model)selectedLeaf));
				break;
			case JPatchTreeNode.MATERIALS:
				replacePanel(new MaterialsPanel((Model)selectedLeaf.getParent()));
				break;
			case JPatchTreeNode.MATERIAL:
				replacePanel(new MaterialPanel((JPatchMaterial)selectedLeaf));
				break;
			case JPatchTreeNode.MORPHS:
				replacePanel(new MorphsPanel((JPatchTreeNode)selectedLeaf));
				break;
			case JPatchTreeNode.MORPH:
				replacePanel(new MorphPanel((Morph)selectedLeaf));
				break;
			case JPatchTreeNode.MORPHGROUP:
				replacePanel(new MorphGroupPanel((JPatchTreeNode)selectedLeaf));
				break;
			case JPatchTreeNode.SELECTIONS:
				replacePanel(new SelectionsPanel((Model)selectedLeaf.getParent()));
				break;
			case JPatchTreeNode.SELECTION:
				replacePanel(new SelectionPanel((Selection) selectedLeaf));
				//Selection selection = (Selection) selectedLeaf;
				//System.out.println(selection + " " + selectedLeaf.getParent());
				MainFrame.getInstance().getUndoManager().addEdit(new ChangeSelectionEdit((Selection)selectedLeaf));
				//MainFrame.getInstance().setSelection((Selection)selectedLeaf);
				MainFrame.getInstance().getJPatchScreen().update_all();
				break;
			default:
				replacePanel(new SidePanel());
				break;
		}
		validate();
		//System.out.println(selectedLeaf);
	}
}

