package net.sf.jpatch.boundary.action;

import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.boundary.selection.*;
import net.sf.jpatch.control.edit.*;
import net.sf.jpatch.entity.*;

public final class DetachControlPointsAction extends AbstractAction {
	
	public DetachControlPointsAction() {
		super("",new ImageIcon(ClassLoader.getSystemResource("net/sf/jpatch/images/detach.png")));
		putValue(Action.SHORT_DESCRIPTION,"Detach points");
	}
	
	public void actionPerformed(ActionEvent actionEvent) {
		PointSelection ps = MainFrame.getInstance().getPointSelection();
		if (ps != null && ps.isSingle()) {
			if (ps.isCurve()) {
				MainFrame.getInstance().getUndoManager().addEdit(new FullyDetachControlPointEdit(ps.getControlPoint()));
				MainFrame.getInstance().getJPatchScreen().update_all();
			} else {
				ControlPoint[] acp = ps.getControlPoint().getStack();
				JPatchCompoundEdit compoundEdit = new JPatchCompoundEdit("detach");
				for (int i = 0; i < acp.length; i++) {
					compoundEdit.addEdit(new FullyDetachControlPointEdit(acp[i]));
				}
				MainFrame.getInstance().getUndoManager().addEdit(compoundEdit);
				MainFrame.getInstance().getJPatchScreen().update_all();
			}
		}
	}
}
