package net.sf.jpatch.boundary.action;

import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.boundary.selection.*;
import net.sf.jpatch.control.edit.*;
import net.sf.jpatch.entity.*;

public final class ExtendSelectionAction extends AbstractAction {
	private HashSet setPoints;
	
	public ExtendSelectionAction() {
		super("extend selection");
		//putValue(Action.SHORT_DESCRIPTION,KeyMapping.getDescription("add point"));
		//MainFrame.getInstance().getKeyEventDispatcher().setKeyActionListener(this,KeyEvent.VK_A);
	}
	
	public void actionPerformed(ActionEvent actionEvent) {
		PointSelection ps = MainFrame.getInstance().getPointSelection();
		JPatchCompoundEdit compoundEdit = new JPatchCompoundEdit();
		if (ps != null) {
			Collection pointsToAdd = new ArrayList();
			Collection pointsToRemove = new ArrayList();
			boolean cont = true;
			if (ps.isSingle()) {
				ControlPoint cpa = ps.getControlPoint();
				if (ps.isCurve() || cpa.getPrevAttached() == null) {
					for (ControlPoint cp = cpa.getCurve().getStart(); cp != null; cp = cp.getNextCheckNextLoop()) {
						pointsToAdd.add(cp.getHead());
						//ps.addControlPoint(cp.getHead());
					}
					if (!cpa.isHead()) {
						pointsToRemove.add(cpa);
						//ps.removeControlPoint(cpa);
					}
					cont = false;
				}
			}
			if (cont) {
				setPoints = new HashSet();
				ControlPoint[] acp = ps.getControlPointArray();
				for (int i = 0; i < acp.length; selectPoint(acp[i++]));
				//ps.getSelectedControlPoints().addAll(setPoints);
				pointsToAdd.addAll(setPoints);
				pointsToAdd.removeAll(ps.getSelectedControlPoints());
			}
			compoundEdit.addEdit(new AddControlPointsToSelectionEdit(ps,pointsToAdd));
			compoundEdit.addEdit(new RemoveControlPointsFromSelectionEdit(ps,pointsToRemove));
			MainFrame.getInstance().getUndoManager().addEdit(compoundEdit);
			MainFrame.getInstance().getJPatchScreen().update_all();
		}
	}
	
	private void selectPoint(ControlPoint cp) {
		if (cp != null) {
			cp = cp.getHead();
			if (!setPoints.contains(cp)) {
				setPoints.add(cp);
				ControlPoint[] stack = cp.getStack();
				for (int i = 0; i < stack.length; i++) {
					selectPoint(stack[i].getNext());
					selectPoint(stack[i].getPrev());
				}
			}
		}
	}
}
