package net.sf.jpatch.boundary.action;

import java.util.*;
import java.awt.event.*;
import javax.swing.*;
import net.sf.jpatch.control.edit.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.boundary.selection.*;
import net.sf.jpatch.entity.*;
import net.sf.jpatch.auxilary.*;

public final class HideAction extends AbstractAction {
	private boolean bActive = false;
	
	public HideAction() {
		super("",new ImageIcon(ClassLoader.getSystemResource("net/sf/jpatch/images/hide.png")));
		putValue(Action.SHORT_DESCRIPTION,KeyMapping.getDescription("hide"));
	}
	public void actionPerformed(ActionEvent actionEvent) {
		if (!bActive) {
			PointSelection ps = MainFrame.getInstance().getPointSelection();
			if (ps != null) {
				ControlPoint[] acp = ps.getControlPointArray();
				ArrayList selectedPoints = new ArrayList();
				for (int i = 0; i < acp.length; i++) {
					selectedPoints.add(acp[i].getHead());
					if (acp[i].isHook()) {
						selectedPoints.add(acp[i].trueHead());
					}
				}
				Curve curve = MainFrame.getInstance().getModel().getFirstCurve();
				while (curve != null) {
					ControlPoint cp = curve.getStart();
					while (cp != null) {
						cp.setHidden(!selectedPoints.contains(cp.trueHead()));
						cp = cp.getNextCheckNextLoop();
					}
					curve = curve.getNext();
				}
			} else {
				Curve curve = MainFrame.getInstance().getModel().getFirstCurve();
				while (curve != null) {
					ControlPoint cp = curve.getStart();
					while (cp != null) {
						cp.setHidden(true);
						cp = cp.getNextCheckNextLoop();
					}
					curve = curve.getNext();
				}
			}
		} else {
			Curve curve = MainFrame.getInstance().getModel().getFirstCurve();
			while (curve != null) {
				ControlPoint cp = curve.getStart();
				while (cp != null) {
					cp.setHidden(false);
					cp = cp.getNextCheckNextLoop();
				}
			curve = curve.getNext();
			}
		}
		MainFrame.getInstance().getJPatchScreen().update_all();
		bActive = !bActive;
	}
}
