package net.sf.jpatch.boundary.action;

import java.io.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import net.sf.jpatch.auxilary.*;
import net.sf.jpatch.entity.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.boundary.filefilters.*;
import net.sf.jpatch.boundary.mouse.*;
import net.sf.jpatch.control.*;
import net.sf.jpatch.control.importer.*;

public final class ImportJPatchAction extends AbstractAction {
	public ImportJPatchAction() {
		super("",new ImageIcon(ClassLoader.getSystemResource("net/sf/jpatch/images/open.png")));
		putValue(Action.SHORT_DESCRIPTION,"Open");
	}
	public void actionPerformed(ActionEvent actionEvent) {
		if (MainFrame.getInstance().getUndoManager().hasChanged()) {
			int option = JPatchUtils.showSaveDialog();switch (option) {
				
				case JOptionPane.YES_OPTION:
					SaveAsAction saveAsAction = new SaveAsAction(false);
					if (saveAsAction.save()) {
						load();
					}
					break;
				
				case JOptionPane.NO_OPTION:
					load();
			}
		} else {
			load();
		}
	}
	
	private void load() {
		JFileChooser fileChooser = new JFileChooser(JPatchSettings.getInstance().strJPatchPath);
		javax.swing.filechooser.FileFilter defaultFileFilter = new JPatchFilter();
		fileChooser.addChoosableFileFilter(defaultFileFilter);
		fileChooser.addChoosableFileFilter(new AMFilter());
		fileChooser.addChoosableFileFilter(new SPatchFilter());
		fileChooser.setFileFilter(defaultFileFilter);
		if (fileChooser.showOpenDialog(MainFrame.getInstance()) == JFileChooser.APPROVE_OPTION) {
			File file = fileChooser.getSelectedFile();
			String filename = file.getPath();
			MainFrame.getInstance().NEW();
			ModelImporter modelImporter;
			String extension = JPatchUtils.getFileExtension(filename);
			//System.out.println(extension);
			if (extension.equals("spt")) {
				modelImporter = new SPatchImport();
				JPatchSettings.getInstance().strJPatchPath = file.getParent();
			} else if (extension.equals("mdl")) {
				modelImporter = new AnimationMasterImport();
				JPatchSettings.getInstance().strJPatchPath = file.getParent();
			} else {
				modelImporter = new JPatchImport();
				JPatchSettings.getInstance().strJPatchPath = file.getParent();
				JPatchSettings.getInstance().strJPatchFile = filename;
			}
			modelImporter.importModel(MainFrame.getInstance().getModel(),filename);
		}
	}
}

