package net.sf.jpatch.boundary.action;

import java.io.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import net.sf.jpatch.auxilary.*;
import net.sf.jpatch.entity.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.boundary.filefilters.*;

import net.sf.jpatch.boundary.mouse.*;
import net.sf.jpatch.control.*;
import net.sf.jpatch.control.importer.*;

public final class ImportSPatchAction extends AbstractAction {
	public ImportSPatchAction() {
		super("sPatch [.spt]");
	}
	public void actionPerformed(ActionEvent actionEvent) {
		if (MainFrame.getInstance().getUndoManager().hasChanged()) {
			int option = JPatchUtils.showSaveDialog();switch (option) {
				
				case JOptionPane.YES_OPTION:
					SaveAsAction saveAsAction = new SaveAsAction(false);
					if (saveAsAction.save()) {
						load();
					}
					break;
				
				case JOptionPane.NO_OPTION:
					load();
			}
		} else {
			load();
		}
	}
	
	private void load() {
		JFileChooser fileChooser = new JFileChooser(JPatchSettings.getInstance().strSPatchPath);
		fileChooser.addChoosableFileFilter(new SPatchFilter());
		if (fileChooser.showOpenDialog(MainFrame.getInstance()) == JFileChooser.APPROVE_OPTION) {
			File file = fileChooser.getSelectedFile();
			String filename = file.getPath();
			//MainFrame.getInstance().NEW();
			ModelImporter modelImporter = new SPatchImport();
			modelImporter.importModel(MainFrame.getInstance().getModel(),filename);
			//MainFrame.getInstance().getModel().computePatches();
			JPatchSettings.getInstance().strSPatchPath = file.getParent();
		}
	}
}

