package net.sf.jpatch.boundary.action;

import javax.swing.*;
import java.awt.event.*;
import java.io.*;
import net.sf.jpatch.auxilary.*;
import net.sf.jpatch.entity.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.boundary.filefilters.*;

public final class SaveAsAction extends AbstractAction {
	
	private boolean bSaveAs;
	
	public SaveAsAction(boolean saveAs) {
		super("",new ImageIcon(ClassLoader.getSystemResource("net/sf/jpatch/images/save.png")));
		bSaveAs = saveAs;
		if (saveAs) {
			putValue(Action.SHORT_DESCRIPTION,"Save As...");
		} else {
			putValue(Action.SHORT_DESCRIPTION,"Save");
		}
	}
	
	public void actionPerformed(ActionEvent actionEvent) {
		////System.out.println(MainFrame.getInstance().getModel().xml(0));
		//JFileChooser fileChooser = new JFileChooser(JPatchSettings.getInstance().strJPatchPath);
		//if (fileChooser.showSaveDialog(MainFrame.getInstance()) == JFileChooser.APPROVE_OPTION) {
		//	File file = fileChooser.getSelectedFile();
		//	String filename = file.getPath();
		//	if (JPatchUtils.getFileExtension(filename).equals("")) {
		//		filename += ".jpx";
		//	}
		//	try {
		//		BufferedWriter writer = new BufferedWriter(new FileWriter(filename));
		//		writer.write(MainFrame.getInstance().getModel().xml(0).toString());
		//		writer.close();
		//		MainFrame.getInstance().getUndoManager().setChange(false);
		//	} catch (IOException e) {
		//		;
		//	}
		//	JPatchSettings.getInstance().strJPatchPath = file.getParent();
		//}
		if (bSaveAs) {
			saveAs();
		} else {
			save();
		}
	}
	
	public boolean saveAs() {
		JFileChooser fileChooser = new JFileChooser(JPatchSettings.getInstance().strJPatchPath);
		fileChooser.addChoosableFileFilter(new JPatchFilter());
		if (fileChooser.showSaveDialog(MainFrame.getInstance()) == JFileChooser.APPROVE_OPTION) {
			File file = fileChooser.getSelectedFile();
			String filename = file.getPath();
			//System.out.println(filename + " " + JPatchUtils.getFileExtension(file.getName()));
			if (JPatchUtils.getFileExtension(file.getName()).equals("")) {
				filename += ".jpx";
			}
			if (write(filename)) {
				JPatchSettings.getInstance().strJPatchFile = filename;
				return true;
			}
		}
		return false;
	}
		
		
	public boolean save() {
		String filename = JPatchSettings.getInstance().strJPatchFile;
		if (filename.equals("")) {
			return saveAs();
		} else {
			return write(filename);
		}
	}
	
	private boolean write(String filename) {
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(filename));
			writer.write(MainFrame.getInstance().getModel().xml(0).toString());
			writer.close();
			MainFrame.getInstance().getUndoManager().setChange(false);
			//System.out.println("file " + filename + " written.");
			return true;
		} catch (IOException ioException) {
			JOptionPane.showMessageDialog(MainFrame.getInstance(),"Unable to save file \"" + filename + "\"\n" + ioException, "Error", JOptionPane.ERROR_MESSAGE);
			return false;
		}
	}
}
