package net.sf.jpatch.boundary.action;

import javax.swing.*;
import java.awt.event.*;
import java.io.*;
import net.sf.jpatch.auxilary.*;
import net.sf.jpatch.entity.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.boundary.filefilters.*;
import net.sf.jpatch.renderer.*;

public final class TestRenderPovRayAction extends AbstractAction {
	public TestRenderPovRayAction() {
		super("POV-Ray");
	}
	public void actionPerformed(ActionEvent actionEvent) {
		JFileChooser fileChooser = new JFileChooser(JPatchSettings.getInstance().strPovrayPath);
		fileChooser.addChoosableFileFilter(new PovFilter());
		if (fileChooser.showSaveDialog(MainFrame.getInstance()) == JFileChooser.APPROVE_OPTION) {
			File file = fileChooser.getSelectedFile();
			String filename = file.getPath();
			if (JPatchUtils.getFileExtension(file.getName()).equals("")) {
				filename += ".inc";
			}
			JPatchRenderer renderer = new PovrayRenderer();
			renderer.writeToFile(filename);
			JPatchSettings.getInstance().strPovrayPath = file.getParent();
		}
	}
}
