package net.sf.jpatch.boundary.mouse;

import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.undo.*;
import javax.vecmath.*;
import net.sf.jpatch.entity.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.boundary.selection.*;
import net.sf.jpatch.boundary.dialog.*;
import net.sf.jpatch.control.edit.*;
import java.io.*;

public class ChangeBiasMouseAdapter extends JPatchMouseAdapter {
	
	private Component compSource;
	private BiasDialog biasDialog;
	
	public ChangeBiasMouseAdapter(BiasDialog biasDialog) {
		this.biasDialog = biasDialog;
	}
	
	public void mousePressed(MouseEvent mouseEvent) {
		if (mouseEvent.getButton() == MouseEvent.BUTTON1) {
			compSource = (Component)mouseEvent.getSource();
			Viewport viewport = (Viewport)mouseEvent.getSource();
			int iMouseX = mouseEvent.getX();
			int iMouseY = mouseEvent.getY();
			ControlPoint cp = viewport.getViewDefinition().getClosestControlPoint(new Point2D.Float(iMouseX,iMouseY),null,true);
			biasDialog.setControlPoint(cp);
			MainFrame.getInstance().setTangentDisplay(cp);
			MainFrame.getInstance().getJPatchScreen().repaint();
		}
	}
}

