package net.sf.jpatch.boundary.mouse;

import java.awt.*;
import java.awt.event.*;
import net.sf.jpatch.boundary.*;

public class MoveZoomMouseAdapter extends JPatchMouseAdapter {
	private int iMouseX;
	private int iMouseY;
	private float fMin;
	
	public void mousePressed(MouseEvent mouseEvent) {
		if (mouseEvent.getButton() == MouseEvent.BUTTON2) {
			((Component)mouseEvent.getSource()).addMouseMotionListener(this);
			iMouseX = mouseEvent.getX();
			iMouseY = mouseEvent.getY();
		}
	}
	
	public void mouseReleased(MouseEvent mouseEvent) {
		if (mouseEvent.getButton() == MouseEvent.BUTTON2) {
			((Component)mouseEvent.getSource()).removeMouseMotionListener(this);
		}
	}
	
	public void mouseDragged(MouseEvent mouseEvent) {
		int deltaX = mouseEvent.getX() - iMouseX;
		int deltaY = mouseEvent.getY() - iMouseY;
		iMouseX = mouseEvent.getX();
		iMouseY = mouseEvent.getY();
		int iWidth = ((Component)(mouseEvent.getSource())).getWidth();
		int iHeight = ((Component)(mouseEvent.getSource())).getHeight();
		//fMin = (iWidth < iHeight) ? iWidth : iHeight;
		fMin = iWidth/2;
		((Viewport)(mouseEvent.getSource())).getViewDefinition().moveView((float)deltaX/fMin,(float)deltaY/fMin);
	}
	
	public void mouseWheelMoved(MouseWheelEvent mouseWheelEvent) {
		int wheelClicks = mouseWheelEvent.getWheelRotation();
		float scale = (1-((float)wheelClicks)/8);
		if (scale < 0.2) scale = (float)0.2;
		if (scale > 5) scale = (float)5;
		((Viewport)(mouseWheelEvent.getSource())).getViewDefinition().scaleView(scale);
	}
}
