package net.sf.jpatch.boundary.sidebar;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import net.sf.jpatch.boundary.action.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.entity.*;

public class MorphPanel extends SidePanel
implements ChangeListener {
	
	JPatchInput inputName;
	JPanel panelMinMax = new JPanel();
	JPatchInput inputMin;
	JPatchInput inputMax;
	JPatchSlider slider;
	Morph morph;
	
	public MorphPanel(Morph morph) {
		this.morph = morph;
		add(new JButton("delete"));
		JPatchSlider.setDimensions(0,150,50,20);
		JPanel detailPanel = MainFrame.getInstance().getSideBar().getDetailPanel();
		JPatchInput.setDimensions(50,150,20);
		inputName = new JPatchInput("Name:",morph.getName());
		panelMinMax.setLayout(new BoxLayout(panelMinMax,BoxLayout.X_AXIS));
		JPatchInput.setDimensions(50,50,20);
		inputMin = new JPatchInput("Min:",morph.getMin());
		inputMax = new JPatchInput("Max:",morph.getMax());
		panelMinMax.add(inputMin);
		panelMinMax.add(inputMax);
		detailPanel.removeAll();
		detailPanel.add(inputName);
		detailPanel.add(panelMinMax);
		slider = new JPatchSlider("",morph.getMin(),morph.getMax(),morph.getValue());
		detailPanel.add(slider);
		detailPanel.repaint();
		inputName.addChangeListener(this);
		inputMin.addChangeListener(this);
		inputMax.addChangeListener(this);
	}
	public void stateChanged(ChangeEvent changeEvent) {
		if (changeEvent.getSource() == inputName) {
			morph.setName(inputName.getStringValue());
			((DefaultTreeModel)MainFrame.getInstance().getTree().getModel()).nodeChanged(morph);
		} else if (changeEvent.getSource() == inputMin) {
			morph.setMin(inputMin.getFloatValue());
			slider.setRange(morph.getMin(),morph.getMax());
		} else if (changeEvent.getSource() == inputMax) {
			morph.setMax(inputMax.getFloatValue());
			slider.setRange(morph.getMin(),morph.getMax());
		}
	}
}

