package net.sf.jpatch.control.edit;

import net.sf.jpatch.entity.*;

class EraseControlPointEdit extends JPatchAbstractUndoableEdit {
	private ControlPoint cp;
	private ControlPoint cpClone;
	
	public EraseControlPointEdit(ControlPoint cp) {
		this.cp = cp;
		cpClone = cp.createClone();
		erase();
	}
	
	public void undo() {
		unErase();
	}
	
	public void redo() {
		erase();
	}
	
	private void erase() {
		cp.free();
	}
	
	private void unErase() {
		cp.cloneFrom(cpClone);
	}
}
