package net.sf.jpatch.control.edit;

import javax.vecmath.*;
import javax.swing.undo.*;
import net.sf.jpatch.entity.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.boundary.tools.*;

public class MoveControlPointsEdit extends JPatchAbstractUndoableEdit {
	public static final int TRANSLATE = 1;
	public static final int ROTATE = 2;
	public static final int SCALE = 3;
	
	private ControlPoint[] acp;
	private Point3f[] ap3Position;
	private int iMode;
	private static final String[] astrName = new String[] { "","translate","rotate","scale" };	
	private static int c;
	private static Point3f p3Cache = new Point3f();
	
	public MoveControlPointsEdit(int mode, ControlPoint[] controlPoints) {
		iMode = mode;
		this.acp = controlPoints;
		ap3Position = new Point3f[acp.length];
		for (c = 0; c < acp.length; c++) {
			ap3Position[c] = new Point3f(acp[c].getReferencePosition());
			//System.out.println(ap3Position[c]);
			acp[c].fixPosition();
		}
	}
	
	public String name() {
		return (astrName[iMode]);
	}
	
	public void undo() {
		swap();
		//MainFrame.getInstance().getJPatchScreen().setTool(new DefaultTool());
	}
	
	public void redo() {
		swap();
		//MainFrame.getInstance().getJPatchScreen().setTool(new DefaultTool());
	}
	
	private void swap() {
		for (c = 0; c < acp.length; c++) {
			p3Cache.set(ap3Position[c]);
			ap3Position[c].set(acp[c].getReferencePosition());
			acp[c].setReferencePosition(p3Cache);
			acp[c].recomputePosition();
		}
		MainFrame.getInstance().getJPatchScreen().repaint();
	}
}

			
