package net.sf.jpatch.control.edit;

import javax.swing.tree.*;
import net.sf.jpatch.entity.*;
import net.sf.jpatch.boundary.selection.*;
import net.sf.jpatch.boundary.sidebar.*;
import net.sf.jpatch.boundary.*;

public class RemoveSelectionEdit extends JPatchAbstractUndoableEdit {
	
	private Selection selection;
	
	public RemoveSelectionEdit(Selection selection) {
		this.selection = selection;
		redo();
	}
	
	public String getPresentationName() {
		return "remove selection";
	}
	
	public void redo() {
		int[] aiIndex = new int[] { selection.getParent().getIndex(selection) };
		Object[] aObject = new Object[] { selection };
		MainFrame.getInstance().getModel().removeSelection(selection);
		((DefaultTreeModel)MainFrame.getInstance().getTree().getModel()).nodesWereRemoved(selection.getParent(),aiIndex,aObject);
		MainFrame.getInstance().getSideBar().replacePanel(new SidePanel());
		MainFrame.getInstance().getSideBar().clearDetailPanel();
		MainFrame.getInstance().getSideBar().validate();
	}
	
	public void undo() {
		MainFrame.getInstance().getModel().addSelection(selection);
		int[] aiIndex = new int[] { selection.getParent().getIndex(selection) };
		((DefaultTreeModel)MainFrame.getInstance().getTree().getModel()).nodesWereInserted(selection.getParent(),aiIndex);
		TreePath path = selection.getTreePath();
		
		MainFrame.getInstance().getSideBar().replacePanel(new SidePanel());
		MainFrame.getInstance().getSideBar().clearDetailPanel();
		MainFrame.getInstance().getSideBar().validate();
		//MainFrame.getInstance().getTree().setSelectionPath(path);
		//MainFrame.getInstance().getTree().makeVisible(path);
	}
}
