package net.sf.jpatch.control.edit;

import net.sf.jpatch.entity.*;
import net.sf.jpatch.boundary.*;

public class WeldControlPointsEdit extends JPatchCompoundEdit {

	public WeldControlPointsEdit(ControlPoint cpA, ControlPoint cpB) {
		super("weld");
		ControlPoint cpLooseEndA = cpA.getLooseEnd();
		ControlPoint cpLooseEndB = cpB.getLooseEnd();
		if(cpLooseEndA != null && cpLooseEndB != null) {
			
			if (cpLooseEndA.getNextAttached() != null) {
				addEdit(new AttachControlPointsEdit(cpLooseEndB.getHead(),cpLooseEndA.getNextAttached()));
			}
			if (cpLooseEndA.getPrevAttached() != null) {
				addEdit(new AttachControlPointsEdit(cpLooseEndA.getPrevAttached(),cpLooseEndB.getTail()));
			}
			addEdit(new ComplexAppendControlPointsEdit(cpLooseEndA, cpLooseEndB));
		} else {
			addEdit(new AttachControlPointsEdit(cpA.getHead(),cpB.getTail()));
		}
	}
}
