package net.sf.jpatch.plugin;

import java.net.*;

public class PluginClassLoader extends URLClassLoader {
	
	private URL url;
	
	public PluginClassLoader(URL url) {
		super(new URL[] { url });
		this.url = url;
	}
	
	public String getMainClassName() throws IOExceltion {
		URL u = new URL("jar", "", url + "!/");
		JarURLConnection jarUrlConnection = (JarURLConnection)u.openConnection();
		Attributes attributes = jarUrlConnection.getMainAttributes();
		return attributes != null ? attributes.getValue(Attributes.Name.MAIN_CLASS) : null;
	}
	
	public void initPlugin(String className) {
		Class cls = loadClass(className);
		Method methodInit = cls.getMethod("init", null);
		methodInit.setAccessible(true);
		try {
			methodInit.invoke(null,null);
		} catch (IlligalAccessException exception) {
		}
	}
}
