package net.sf.jpatch.plugin;

import java.net.*;
import java.io.*;
import java.lang.reflect.*;
import java.util.jar.*;
//import net.sf.jpatch.plugins.*;

public class PluginClassLoader extends URLClassLoader {
	
	private URL url;
	
	public PluginClassLoader(URL url) {
		super(new URL[] { url });
		this.url = url;
	}
	
	public String getMainClassName() throws IOException {
		URL u = new URL("jar", "", url + "!/");
		JarURLConnection jarUrlConnection = (JarURLConnection)u.openConnection();
		Attributes attributes = jarUrlConnection.getMainAttributes();
		return attributes != null ? attributes.getValue(Attributes.Name.MAIN_CLASS) : null;
	}
	
	public JPatchPlugin loadPlugin(String className)
	throws ClassNotFoundException, IllegalAccessException, InstantiationException {
		Class cls = loadClass(className);
		Object obj = cls.newInstance();
		return (JPatchPlugin)obj;
	}
}
