package net.sf.jpatch.plugin;

import java.io.*;
import java.net.*;
//import net.sf.jpatch.plugins.*;
import net.sf.jpatch.auxilary.*;

public class PluginManager {
	
	public static String strPluginPath = "plugins/";
	
	public JPatchPlugin loadPlugin(PluginClassLoader pluginClassLoader) throws Exception {
		String mainClassName = pluginClassLoader.getMainClassName();
		//System.out.println("classname = " + mainClassName);
		return pluginClassLoader.loadPlugin(mainClassName);	
	}
	
	public void test() {
		try {
			URL url = new URL("file:plugins/magnettool.jar");
			PluginClassLoader pluginClassLoader = new PluginClassLoader(url);
			JPatchPlugin plugin = loadPlugin(pluginClassLoader);
			plugin.init("plugins/magnettool.jar");
			//System.out.println("Plugin name = " + plugin.getPluginID());
		} catch(Exception exception) {
			System.out.println(exception.getMessage());
			System.out.println(exception.getStackTrace());
		}
	}
	
	public void loadPlugins() {
		System.out.println("=================================");
		System.out.println("      JPatch Plugin Manager      ");
		System.out.println("=================================");
		System.out.println("");
		System.out.println("Loading plugins from " + strPluginPath);
		System.out.println("");
		File filePluginPath = new File(strPluginPath);
		File[] afilePlugin = filePluginPath.listFiles(new JarFileFilter());
		for (int i = 0; i < afilePlugin.length; i++) {
			String path = afilePlugin[i].getPath();
			
			System.out.print(afilePlugin[i].getName() + ":");
			try {
				URL urlPlugin = new URL("file:" + path);
			
				PluginClassLoader pluginClassLoader = new PluginClassLoader(urlPlugin);
				JPatchPlugin plugin = loadPlugin(pluginClassLoader);
				if (plugin.init(path)) {
					
					System.out.println(plugin.getPluginID() + " sucessfully loaded");
					
				} else {
					
					System.out.println("FAILED");
				
				}
			} catch(Exception exception) {
				System.out.println(exception.getMessage());
				System.out.println(exception.getStackTrace());
			}
		}
	}
}

