package net.sf.jpatch.render;

import javax.vecmath.*;

public class RCamera {
	private Matrix4f m4View = new Matrix4f();
	private float fFocalLength;
	private Point3f p3Position = new Point3f();
	
	public RCamera() {
		fFocalLength = 50;
		m4View.setIdentity();
	}
	
	public void setPosition(float x, float y, float z) {
		p3Position.set(x,y,z);
		m4View.setTranslation(new Vector3f(-x,-y,-z));
	}
	
	public void pointAt(float x, float y, float z) {
		Vector3f direction = new Vector3f(x,y,z);
		direction.sub(p3Position);
		System.out.println(m4View);
		m4View.setRotationScale(pointAt(direction));
		System.out.println(m4View);
	}
	
	public void setFocalLength(float focalLength) {
		fFocalLength = focalLength;
	}
	
	public Matrix4f getMatrix() {
		return m4View;
	}
	
	public float getFocalLength(float screenWidth) {
		return fFocalLength / 35f * screenWidth;
	}
	
	private Vector3f perpindicularVector(Vector3f v0) {
		Vector3f vn = new Vector3f();
		if (v0.lengthSquared() != 0) {
			float Dm = Math.min(Math.min(Math.abs(v0.x),Math.abs(v0.y)),Math.abs(v0.z));
			if (Math.abs(v0.z) == Dm) {
				vn.cross(v0,new Vector3f(0,0,1));
				vn.normalize();
			} else if (Math.abs(v0.y) == Dm) {
				vn.cross(v0,new Vector3f(0,1,0));
				vn.normalize();
			} else {
				vn.cross(v0,new Vector3f(1,0,0));
				vn.normalize();
			}
		}
		return vn;
	}
	
	private Matrix3f pointAt(Vector3f v) {
		Vector3f z = new Vector3f(v);
		z.normalize();
		Vector3f x = perpindicularVector(z);
		Vector3f y = new Vector3f();
		y.cross(x,z);
		Matrix3f matrix = new Matrix3f();
		matrix.setColumn(0,x);
		matrix.setColumn(1,y);
		matrix.setColumn(2,z);
		System.out.println(matrix);
		return matrix;
	}
}
