package net.sf.jpatch.render;

import javax.vecmath.*;

public class RDistantLight implements RLight {
	private Color3f c3LightColor = new Color3f();
	private Vector3d v3LightDirection = new Vector3d();
	private boolean bHighlight;
	
	public RDistantLight(Color3f lightColor, Vector3f lightDirection, boolean highlight) {
		c3LightColor.set(lightColor);
		v3LightDirection.set(-lightDirection.x,-lightDirection.y,-lightDirection.z);
		bHighlight = highlight;
	}
	
	public Color3f lightIntensity(Point3d position) {
		return c3LightColor;
	}
	
	public Vector3d lightDirection(Point3d position) {
		return v3LightDirection;
	}
	
	public boolean highlight() {
		return bHighlight;
	}
}
