package net.sf.jpatch.render;

import java.util.*;
import javax.vecmath.*;
import net.sf.jpatch.entity.*;

public class RScanline {
	public double[][] aadValue;
	public MaterialProperties[] aMaterialProperties;
	public Color3f[] ac3Color;
	
	private int iWidth;
	private Color3f c3BackgroundColor;
	
	public RScanline(int width, Color3f backgroundColor) {
		iWidth = width;
		c3BackgroundColor = backgroundColor;
		aMaterialProperties = new MaterialProperties[width];
		aadValue = new double[width][RConstants.NUM_VALUES];
		ac3Color = new Color3f[width];
		for (int x = 0; x < iWidth; x++) {
			aadValue[x][RConstants.POSITION_R] = 0;
		}
	}
	
	public void shadeScanline(RShader shader, ArrayList lights) {
		//System.out.println("x");
		for (int x = 0; x < iWidth; x++) {
			if (aMaterialProperties[x] != null) {
				ac3Color[x] = shader.shade(aadValue[x],aMaterialProperties[x],lights);
				//System.out.println(" " + ac3Color[x]);
				//aiColor[x] = 0xFF00FF00;
				//ac3Color[x] = new Color3f(1,0,0);
			} else {
				//aiColor[x] = iBackgroundColor;
				ac3Color[x] = c3BackgroundColor;
			}
			//System.out.println(ac3Color[x]);
		}
	}
}
