package net.sf.jpatch.renderer;

import java.io.*;
import java.util.*;
import javax.vecmath.*;
import net.sf.jpatch.entity.*;
import net.sf.jpatch.boundary.*;
import net.sf.jpatch.auxilary.*;

public class TestRenderer2 extends AbstractRenderer {
	public void writeToFile(String filename) {
		BufferedWriter file;
		Model model = MainFrame.getInstance().getModel();
		try {
			file = new BufferedWriter(new FileWriter(filename));
			
			/*
			 * output all Bezier patches, sorted by material
			 */
			for (Iterator iterator = model.getMaterialList().iterator(); iterator.hasNext();) {
				JPatchMaterial material = (JPatchMaterial)iterator.next();
				MaterialProperties mp = material.getMaterialProperties();
				boolean active = false;
				for(Patch patch = model.getFirstPatch();patch != null; patch = patch.getNext()) {
					if (patch.getMaterial() == material) {
						if (!active) {
							/* write material properties */
							file.write("m " + mp.red + " " + mp.green + " " + mp.blue + " ");
							file.write(mp.ambient + " " + mp.diffuse + " " + mp.brilliance + " ");
							file.write(mp.specular + " " + mp.roughness + " ");
							file.newLine();
							active = true;
						}
						Point3f[][] bicubicPatches = patch.bicubicPatches();
						for (int p = 0; p < bicubicPatches.length; p++) {
							Point3f[] bcp = bicubicPatches[p];
							file.write("b");
							for (int i = 0; i < 16; i++) {
								file.write(" " + bcp[i].x + " " + bcp[i].y + " " + bcp[i].z);
							}
							file.newLine();
						}
					}
				}
			}
			
			file.close();
		} catch (IOException e) {
			System.err.println(e.getMessage());
		}
	}		
}
